unit arrayspeed;

interface

{ This project shows how to speed up adding many points
  to a Series.
  It has most sense when used with a FastLine series in 2D mode,
  but can speed also the rest of series.

  Note:

  The advantage of gaining speed has also some
  (minor) disavantadges:

    -You should calculate the "X" position for each point
      ( This is normally the "Count" of Series points )

    -The Series "OnBeforeAdd" event is not triggered.

    -Points cannot have Colors or text Labels.
      ( The text and color parameters of the normal Add method
        are not used. )

    -If the Series is the DataSource of other Series or
     Functions, then adding points in the "fast way", will not
     recalculate the functions.
     You can do so after adding points: Series1.RefreshSeries


}
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  TeEngine, Series, ExtCtrls, TeeProcs, Chart, StdCtrls;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    Series1: TFastLineSeries;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var t,tmp:Integer;
    t1:DWord;
begin
  t1:=GetTickCount;
  Series1.Clear;
  Series1.SeriesColor:=clRed;
  tmp:=Random(1000);
  for t:=1 to 40000 do
  With Series1 do
  begin
    tmp:=tmp+Random(1000)-500;
    Add(tmp);
  end;
  Label1.Caption:=InttoStr(GetTickCount-t1);
end;

{ this is a trick necessary... }
type TMyList=class(TChartValueList)
     end;

procedure TForm1.Button2Click(Sender: TObject);
var t,tmp:Integer;
    t1:DWord;
begin
  t1:=GetTickCount;
  Series1.Clear;
  Series1.SeriesColor:=clGreen;
  tmp:=Random(1000);
  for t:=1 to 40000 do
  With Series1 do
  begin
    tmp:=tmp+Random(1000)-500;

   { this line is the important: }
   TMyList(YValues).InsertChartValue(
            TMyList(XValues).AddChartValue(Count), tmp);

  end;
  Label1.Caption:=InttoStr(GetTickCount-t1);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Series1.XValues.Order:=loNone;
end;

end.
